function love.load()
	--Löve setup
	love.window.setTitle("Genetic algorithm")

	--Loading modules
	fmath = require("fmath")
	vec = require("vector")
	entity = require("entity")
	population = require("population")

	--Globals
	width = love.graphics.getWidth()
	height = love.graphics.getHeight()

	--Simulation properties
	POPULATION_SIZE = 1000
	STEPS = 200
	MUTATION_CHANSE = 0.01
	POPULATION_POSITION = {x = width * 0.9, y = height * 0.9}

	--stats
	GENERATION = 1
	REACHED_GOAL = 0
	HIT_BORDER = 0
	HIT_OBSTACLE = 0
	OLD_AGE = 0

	goal = {
		x = 64,
		y = 64,
		radius = 32
	}

	obstacle = {
		x = width / 2,
		y = height / 2,
		radius = 100
	}

	pop = population.new(POPULATION_SIZE)
end

function love.update(dt)
	pop:update(dt)

	if pop:extinct() then
		pop:nextGen()
		GENERATION = GENERATION + 1
	end
end

function love.draw()
	--Goal
	love.graphics.setColor(0, 1, 0, 0.2)
	love.graphics.circle("fill", goal.x, goal.y, goal.radius)
	love.graphics.setColor(0, 1, 0, 1)
	love.graphics.circle("line", goal.x, goal.y, goal.radius)

	--Obstacle
	love.graphics.setColor(1, 0, 0, 0.2)
	love.graphics.circle("fill", obstacle.x, obstacle.y, obstacle.radius)
	love.graphics.setColor(1, 0, 0, 1)
	love.graphics.circle("line", obstacle.x, obstacle.y, obstacle.radius)
	pop:draw()

	pop:draw()

	love.graphics.setColor(1, 1, 1)
	love.graphics.printf("Population size: "..POPULATION_SIZE.."\nGENERATION: "..GENERATION.."\nReached goal: "..REACHED_GOAL.."\nHit border: "..HIT_BORDER.."\nHit obstacle: "..HIT_OBSTACLE, -12, 12, width, "right")
end

function love.keypressed(key)
	if key == "escape" then
		love.event.push("quit")
	elseif key == "space" then
		love.load()
	end
end

--I ganked this function from: http://lua-users.org/wiki/CopyTable
function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end